/**
 * Copyright (C) 2008-2009 RobotBrain. All Rights Reserved.
 * ̃vO̓t[\tgEFAłBȂ͂t[\tgEFAc
 * ɂĔsꂽGNU򓙈ʌOpo[W3(LGPLv3)߂
 * ōĔЕz܂͉ς邱Ƃł܂B
 * ̃vO͗Lpł邱ƂĔЕz܂S̖ۏ؂łB
 * Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂܂ߑS݂
 * BڂGNU򓙈ʌOpo[W3(LGPLv3)B
 * Ȃ͂̃vOƋɁAGNU򓙈ʌOpo[W3(LGPLv3)
 * Rs[ꕔ󂯎Ă͂łB
 * 󂯎ĂȂ<http://www.gnu.org/licenses/>B
 */
package jp.robotbrain.framework;

import java.io.PrintStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;


/**
 * p[^̃Xg
 * 
 * @since 1.00
 * @author Copyright (C) 2008-2009 <a href="http://robotbrain.jp">
 * RobotBrain.</a> All Rights Reserved.
 */
public final class GeneList implements Cloneable, Serializable {

	/**
	 * VAo[Whc
	 * 
	 * @since 1.00
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * p[^Xg
	 * 
	 * @since 1.00
	 */
	private ArrayList<Gene> m_geneList;

	/**
	 * GeneList𐶐܂B
	 * 
	 * @since 1.00
	 */
	public GeneList() {
		m_geneList = new ArrayList<Gene>();
	}
	
	/**
	 * N[𐶐Ԃ܂B
	 * 
	 * @since 1.00
	 * @return N[
	 */
	@Override
	public Object clone() {
		GeneList newGeneList = new GeneList();
		for (Iterator<Gene> i=m_geneList.iterator();i.hasNext();) {
			Gene srcg = i.next();
			try {
				newGeneList.add((Gene)srcg.clone());
			} catch (GeneListException e) {
				e.printStackTrace();
				throw new RuntimeException();
			}
		}
		return newGeneList;
	}
	
	/**
	 * w肳ꂽp[^XgƓemF܂B
	 * ׂĂ̒lꍇɓƔf܂B
	 * 
	 * @since 1.00
	 * @param p_other ̃p[^Xg
	 * @return ꍇtrueԂ
	 */
	public boolean isEquals(GeneList p_other) {
		if (m_geneList.size()!=p_other.size()) return false;
		try {
			for (int i=0;i<m_geneList.size();i++) {
				Gene me = m_geneList.get(i);
				Gene other = p_other.getGene(i);
				if (me.getDoubleValue()!=other.getDoubleValue()) return false;
			}
		} catch (GeneListException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
		return true;
	}

	/**
	 * CX^XɓˑRψق̃p[^Xg𐶐܂B
	 * 
	 * @since 1.00
	 * @return ˑRψّ̂̃p[^Xg
	 */
	public GeneList createMutant() {
		try {
			GeneList mutant = (GeneList)this.clone();
			int no = UtilFramework.random(size()-1);
			mutant.getGene(no).initRandom();
			return mutant;
		} catch (GeneListException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	/**
	 * CX^Xƈœnꂽp[^Xgq̃p[^Xg𐶐܂B
	 * 
	 * @since 1.00
	 * @param p_other z
	 * @param p_heredityRate z̈`B0.0ȏ1.0菬lw肵܂B
	 * @return q̃p[^Xg
	 */
	public GeneList createChild(GeneList p_other, double p_heredityRate) {
		try {
			GeneList child = new GeneList();
			for (int i=0;i<size();i++) {
				child.add(
					UtilFramework.probability( p_heredityRate ) ?
							p_other.getGene(i) : getGene(i) 
				);		
			}
			return child;
		} catch (GeneListException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	/**
	 * l_ɏ܂B
	 * 
	 * @since 1.00
	 */
	public void initRandom() {
		for (Iterator<Gene> i=m_geneList.iterator();i.hasNext();) {
			Gene g = i.next();
			g.initRandom();
		}
	}
	
	/**
	 * p[^ǉ܂B
	 * 
	 * @since 1.00
	 * @param p_gene p[^
	 * @throws GeneListException ǉp[^ɑ݂ꍇ
	 */
	public void add(Gene p_gene) throws GeneListException {
		if (m_geneList.indexOf(p_gene)>=0) 
			throw new GeneListException("It already exists Label " + p_gene.getLabel());
		m_geneList.add(p_gene);
	}
	
	/**
	 * ׂẴp[^폜܂B
	 * 
	 * @since 1.00
	 */
	public void clear() {
		m_geneList.clear();
	}
	
	/**
	 * XgɃp[^܂܂Ă邩Ԃ܂B
	 * 
	 * @since 1.00
	 * @return p[^̌
	 */
	public int size() {
		return m_geneList.size();
	}
	
	/**
	 * w肵xɃ}b`p[^Ԃ܂B
	 * 
	 * @since 1.00
	 * @param p_label x
	 * @return p[^
	 * @throws GeneListException w肵x݂Ȃꍇ
	 */
	public Gene getGene(String p_label) throws GeneListException {
		for (Iterator<Gene> i=m_geneList.iterator();i.hasNext();) {
			Gene g = i.next();
			if (g.getLabel().equals(p_label)) return g;
		}
		throw new GeneListException("Error NotFound Gene Label =" + p_label);
	}
	
	/**
	 * w肵zindexɃ}b`p[^Ԃ܂B
	 * 
	 * @since 1.00
	 * @param p_index zindex
	 * @return p[^
	 * @throws GeneListException w肵zindex݂Ȃꍇ
	 */
	public Gene getGene(int p_index) throws GeneListException {
		if (p_index<0 || p_index>=size()) 
			throw new GeneListException("Error NotFound Gene Index =" + p_index);
		return m_geneList.get(p_index);
	}
	
	/**
	 * p[^Xg̓eo͐Xg[ɏo͂܂B
	 * 
	 * @since 1.00
	 * @param p_out o͐Xg[
	 */
	public void print(PrintStream p_out) {
		for (Iterator<Gene> i=m_geneList.iterator();i.hasNext();) {
			Gene g = i.next();
			p_out.println(g.getStatus());
		}
	}

	/**
	 * p[^̒lJ}؂̕ŕԂ܂B
	 * 
	 * @since 1.00
	 * @return ׂĂ̒l̃J}؂̕ 
	 */
	public String getValuesString() {
		String returnValue = "";
		for (int i=0;i<m_geneList.size();i++) {
			Gene g = m_geneList.get(i);
			returnValue += ((i==0) ? "" : ",")  + UtilFramework.formatDouble(g.getDoubleValue(), g.getScale());
		}
		return returnValue;
	}

	/**
	 * p[^̃xJ}؂̕ŕԂ܂B
	 * 
	 * @since 1.00
	 * @return ׂẴx̃J}؂̕ 
	 */
	public String getLabelsString() {
		String returnValue = "";
		for (int i=0;i<m_geneList.size();i++) {
			Gene g = m_geneList.get(i);
			returnValue += ((i==0) ? "" : ",")  + g.getLabel();
		}
		return returnValue;
	}
	
	/**
	 * p[^̃fUCRs[܂B
	 * 
	 * @since 1.00
	 * @param p_src Rs[
	 */
	public void copyDesign(GeneList p_src) {
		try {
			for (int i=0;i<m_geneList.size();i++) {
				Gene me = this.getGene(i);
				me.copyDesign(p_src.getGene(i));
			}
		} catch (GeneListException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	/**
	 * ꃉx̃p[^ɒlZbg܂B
	 * 
	 * @since 1.00
	 * @param p_src ݒ肷p[^
	 */
	public void setValue(Gene p_src) {
		for (Gene g: m_geneList) {
			if (g.getLabel().equals(p_src.getLabel())) {
				g.setDoubleValue(p_src.getDoubleValue());
			}
		}
	}
	
	/**
	 * w肵p[^Xg̒lZbg܂B
	 * 
	 * @since 1.00
	 * @param p_src ݒ肷p[^Xg
	 */
	public void setValues(GeneList p_src) {
		for (Gene g: p_src.m_geneList) {
			setValue(g);
		}
	}
	
	/**
	 * œKp[^Xg𐶐܂BœKΏۃtOtrueɂȂĂp[^ō\܂B
	 * 
	 * @since 1.00
	 * @return œKp[^Xg
	 */
	public GeneList createOptimizeGeneList() {
		GeneList returnValue = new GeneList();
		for (Gene g: m_geneList) {
			if (g.isOptimize()) {
				try {
					returnValue.add(g);
				} catch (GeneListException e) {
					e.printStackTrace();
					throw new RuntimeException();
				}
			}
		}
		return returnValue;
	}
	
}
