/**
 * Copyright (C) 2009 RobotBrain. All Rights Reserved.
 * ̃vO̓t[\tgEFAłBȂ͂t[\tgEFAc
 * ɂĔsꂽGNU򓙈ʌOpo[W3(LGPLv3)߂
 * ōĔЕz܂͉ς邱Ƃł܂B
 * ̃vO͗Lpł邱ƂĔЕz܂S̖ۏ؂łB
 * Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂܂ߑS݂
 * BڂGNU򓙈ʌOpo[W3(LGPLv3)B
 * Ȃ͂̃vOƋɁAGNU򓙈ʌOpo[W3(LGPLv3)
 * Rs[ꕔ󂯎Ă͂łB
 * 󂯎ĂȂ<http://www.gnu.org/licenses/>B
 */
package jp.robotbrain.signal;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;

/**
 * [\N^C~O^Ce[u
 * 
 * @since 2.00
 * @author Copyright (C) 2009 <a href="http://robotbrain.jp">
 * RobotBrain.</a> All Rights Reserved.
 */
public class CandleStickTimeTable {

	/**
	 * ^Ce[u
	 * 
	 * @since 2.00
	 */
	private HashMap<String,Integer> m_timetable;

	/**
	 * CandleStickTimeTable𐶐܂B
	 * 
	 * @since 2.00
	 * @param p_minute ̃^Ce[u𐶐邩w肵܂BႦ10Ȃ10n܂B
	 */
	public CandleStickTimeTable(int p_minute) {
		try {
			InputStream istream = getClass().getResourceAsStream("cstable/" + p_minute + ".txt");
			if (istream==null) {
				throw new RuntimeException("Candlestick Timetable Not Found minute=" + p_minute);
			}
			BufferedReader br = new BufferedReader(new InputStreamReader(istream));
			m_timetable = new HashMap<String,Integer>();
			while (br.ready()) {
				String line = br.readLine();
				String[] cols = line.split(",");
				if (cols.length!=2) 
					throw new RuntimeException("col count error col=" + cols.length);
				m_timetable.put(cols[0], Integer.parseInt(cols[1]));
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new RuntimeException();
		} catch (IOException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	/**
	 * w肵̃GAԂ܂B
	 * 
	 * @since 2.00
	 * @param p_time 
	 * @return GA
	 */
	synchronized public int lookup(String p_time) {
		return  m_timetable.get(p_time);
	}
	
}
